---
title: in
slug: Web/SVG/Attribute/in
tags:
  - Filters
  - NeedsCompatTable
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>in</code></strong> attribute identifies input for the given filter primitive.</p>

<p>The value can be either one of the six keywords defined below, or a string which matches a previous {{SVGAttr("result")}} attribute value within the same {{SVGElement("filter")}} element. If no value is provided and this is the first filter primitive, then this filter primitive will use <code>SourceGraphic</code> as its input. If no value is provided and this is a subsequent filter primitive, then this filter primitive will use the result from the previous filter primitive as its input.</p>

<p>If the value for {{SVGAttr("result")}} appears multiple times within a given {{SVGElement("filter")}} element, then a reference to that result will use the closest preceding filter primitive with the given value for attribute {{SVGAttr("result")}}.</p>

<p>Fourteen elements are using this attribute: {{SVGElement("feBlend")}}, {{SVGElement("feColorMatrix")}}, {{SVGElement("feComponentTransfer")}}, {{SVGElement("feComposite")}}, {{SVGElement("feConvolveMatrix")}}, {{SVGElement("feDiffuseLighting")}}, {{SVGElement("feDisplacementMap")}}, {{SVGElement("feDropShadow")}}, {{SVGElement("feGaussianBlur")}}, {{SVGElement("feMergeNode")}}, {{SVGElement("feMorphology")}}, {{SVGElement("feOffset")}}, {{SVGElement("feSpecularLighting")}}, {{SVGElement("feTile")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>SourceGraphic</code> | <code>SourceAlpha</code> | <code>BackgroundImage</code> | <code>BackgroundAlpha</code> | <code>FillPaint</code> | <code>StrokePaint</code> | <code>&lt;filter-primitive-reference&gt;</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>SourceGraphic</code> for first filter primitive, otherwise result of previous filter primitive</td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>SourceGraphic</code></dt>
 <dd>This keyword represents the graphics elements that were the original input into the {{SVGElement("filter")}} element.</dd>
 <dt><code>SourceAlpha</code></dt>
 <dd>This keyword represents the graphics elements that were the original input into the <code>&lt;filter&gt;</code> element. <code>SourceAlpha</code> has all of the same rules as <code>SourceGraphic</code> except that only the alpha channel is used.</dd>
 <dt><code>BackgroundImage</code></dt>
 <dd>This keyword represents an image snapshot of the SVG document under the filter region at the time that the <code>&lt;filter&gt;</code> element was invoked.</dd>
 <dt><code>BackgroundAlpha</code></dt>
 <dd>Same as <code>BackgroundImage</code> except only the alpha channel is used.</dd>
 <dt><code>FillPaint</code></dt>
 <dd>This keyword represents the value of the {{SVGAttr("fill")}} property on the target element for the filter effect. In many cases, the <code>FillPaint</code> is opaque everywhere, but that might not be the case if a shape is painted with a gradient or pattern which itself includes transparent or semi-transparent parts.</dd>
 <dt><code>StrokePaint</code></dt>
 <dd>This keyword represents the value of the {{SVGAttr("stroke")}} property on the target element for the filter effect. In many cases, the <code>StrokePaint</code> is opaque everywhere, but that might not be the case if a shape is painted with a gradient or pattern which itself includes transparent or semi-transparent parts.</dd>
 <dt><code>&lt;filter-primitive-reference&gt;</code></dt>
 <dd>This value is an assigned name for the filter primitive in the form of a {{cssxref("custom-ident")}}. If supplied, then graphics that result from processing this filter primitive can be referenced by an in attribute on a subsequent filter primitive within the same filter element. If no value is provided, the output will only be available for re-use as the implicit input into the next filter primitive if that filter primitive provides no value for its in attribute.</dd>
</dl>

<h2 id="Workaround_for_backgroundImage">Workaround for BackgroundImage</h2>

<p>Instead of using <code>in="BackgroundImage"</code>, we need to import one of the images to blend inside the filter itself, using an <code>&lt;feImage&gt; element</code>.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div style="width: 420px; height: 220px;"&gt;
&lt;svg style="width:200px; height:200px; display: inline;" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"&gt;
  &lt;defs&gt;
    &lt;filter id="backgroundMultiply"&gt;
      &lt;!-- This will not work. --&gt;
      &lt;feBlend in="BackgroundImage" in2="SourceGraphic" mode="multiply"/&gt;
    &lt;/filter&gt;
  &lt;/defs&gt;
  &lt;image xlink:href="https://developer.mozilla.org/files/6457/mdn_logo_only_color.png" x="10%" y="10%" width="80%" height="80%"/&gt;
  &lt;circle cx="50%" cy="40%" r="40%" fill="#c00" style="filter:url(#backgroundMultiply);" /&gt;
&lt;/svg&gt;

&lt;svg style="width:200px; height:200px; display: inline;" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"&gt;
  &lt;defs&gt;
    &lt;filter id="imageMultiply"&gt;
      &lt;!-- This is a workaround. --&gt;
      &lt;feImage xlink:href="https://developer.mozilla.org/files/6457/mdn_logo_only_color.png" x="10%" y="10%" width="80%" height="80%"/&gt;
      &lt;feBlend in2="SourceGraphic" mode="multiply"/&gt;
    &lt;/filter&gt;
  &lt;/defs&gt;
  &lt;circle cx="50%" cy="40%" r="40%" fill="#c00" style="filter:url(#imageMultiply);"/&gt;
&lt;/svg&gt;
&lt;/div&gt;</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Workaround_for_backgroundImage")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Filters 1.0", "filters.html#FilterPrimitiveInAttribute", "in")}}</td>
   <td>{{Spec2("Filters 1.0")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "#element-attrdef-filter-primitive-in", "in")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>
